<template>
    <modal
            name="fill-modal"
            transition="nice-modal-fade"
            :min-width="200"
            :min-height="200"
            :pivot-y="1"
            :adaptive="true"
            :scrollable="true"
            :reset="true"
            :max-width="600"
            width="80%"
            height="auto">
        <div class="modal-content">
            <h2 class="modal-h2">Заполнение профиля</h2>
            <div>
                <input type="text" class="text-input" placeholder="Имя"
                       v-model="userInfo.first_name" title="имя" maxlength="20" id="name">
                <input type="text" class="text-input" placeholder="Фамилия"
                       v-model="userInfo.last_name" title="имя" maxlength="20"
                       id="last-name">
                <div class="flex-parent">
                    <div class="for-radio flex-parent">
                        <label for="gender-man" class="radio-label">M</label>
                        <input id="gender-man" v-model="userInfo.gender" value="m" class="radio" type="radio" name="gender">
                    </div>
                    <div class="for-radio flex-parent">
                        <label class="radio-label" for="group-student">Ученик</label>
                        <input id="group-student"  v-model="userInfo.usertype" class="radio"  value="s" type="radio" name="group">
                    </div>
                    <div class="for-radio flex-parent">
                        <label for="gender-woman" class="radio-label">Ж</label>
                        <input id="gender-woman" v-model="userInfo.gender" value="f" class="radio" type="radio" name="gender">
                    </div>
                    <div class="for-radio flex-parent">
                        <label for="group-parent" class="radio-label">Родитель</label>
                        <input id="group-parent" v-model="userInfo.usertype"  value="p" class="radio" type="radio" name="group">
                    </div>
                </div>

                <select class="select" v-model="userInfo.region" required>
                    <option value="" disabled selected>Область</option>
                    <option disabled selected v-if="!regions">Загрузка</option>
                    <option v-for="region in regions" v-bind:value="region.id" v-bind:key="region.id">{{region.name}}</option>
                </select>
                <select class="select" v-model="userInfo.city" required>
                    <option value="" disabled selected>Город</option>
                    <option disabled selected v-if="!cities">Загрузка</option>
                    <option v-for="city in cities" v-bind:value="city.id" v-bind:key="city.id">{{city.name}}</option>
                </select>
                <select class="select" v-model="userInfo.school" required>
                    <option value="" disabled selected>Школа</option>
                    <option disabled selected v-if="!schools">Загрузка</option>
                    <option v-for="school in schools" v-bind:value="school.id" v-bind:key="school.id">{{school.name}}</option>
                </select>
                <!--<select class="select" v-model="userInfo.level" required>-->
                    <!--<option value="" disabled selected>Класс</option>-->
                    <!--<option :value="i" v-for="i in 12">{{i}} класс</option>-->
                    <!--<option value="13">Другое</option>-->
                <!--</select>-->
                <select class="select" v-model="userInfo.language" required>
                    <option value="" disabled selected>Язык обучение</option>
                    <option value="eng">English</option>
                    <option value="rus">Русский</option>
                    <option value="kaz">Қазақша</option>
                </select>
                <button class="a-btn" @click="sendData">Сохранить</button>
            </div>

        </div>
    </modal>
</template>

<script>
    export default {
        name: 'LoginModal',
        data(){
            return{
                file: '',
                showPreview: false,
                imagePreview: '',
                userInfo: {
                    first_name: '',
                    city: '',
                    gender: '',
                    image: '',
                    language:'',
                    last_name: '',
                    level: '',
                    region: '',
                    school: '',
                    usertype: '',
                }
            }
        },
        computed:{
            user(){
                let userInfo = this.$store.getters.user;
                let userInfoArr = Object.entries(userInfo);
                let that = this;
                userInfoArr.forEach((data)=>{
                    that.userInfo[data[0]] = data[1]
                })
                console.log(this)
                return userInfo;
            },
            regions(){
                return this.$store.getters.regions;
            },
            cities(){
                return this.$store.getters.cities;
            },
            schools(){
                return this.$store.getters.schools;
            }
        },
        beforeMount(){
            this.$store.dispatch('loadRegions')
        },
        methods: {
            onChangeFileUpload(){
                this.file = this.$refs.file.files[0];
                console.log(this.file)
                let reader  = new FileReader();


                reader.addEventListener("load", function () {
                    this.showPreview = true;
                    this.imagePreview = reader.result;
                }.bind(this), false);


                if( this.file ){

                    if ( /\.(jpe?g|png|gif)$/i.test( this.file.name ) ) {

                        reader.readAsDataURL( this.file );
                    }
                }
            },
            sendData(){
                let data = new FormData();
                if(this.file){
                    data.append('image', this.file);
                }
                let userInfoArr = Object.entries(this.userInfo);
                let that = this;
                userInfoArr.forEach((info)=>{
                    if(info[1]!=='' && info[1]!==null){
                        data.append(info[0],info[1]);
                    }

                })
                for(var pair of data.entries()) {
                    console.log(pair[0]+ ', '+ pair[1]);
                }
                this.$store.dispatch('updateProfile', data).then(()=>{
                    this.$modal.hide('fill-modal')
                })
            }
        },
        watch: {
            'userInfo.region': function (val, oldVal){
                if(val!==oldVal){
                    console.log(val, oldVal)
                    this.city = '';
                    this.schools = '';
                    this.$store.dispatch('loadCities', this.userInfo.region)
                }
            },
            'userInfo.city': function (val, oldVal){
                if(val!==oldVal){
                    this.schools = '';
                    this.$store.dispatch('loadSchools', this.userInfo.city)
                }
            }
        },
    }
</script>
